using System;
using System.Collections;

public class ProxyClass:A
{
	RealANoVirtual _RealA;
	
	public ProxyClass()
	{
		_RealA = new RealANoVirtual();
	}
	
	private void PreDoSomething()
	{
		WL("Now i'm starting DoSomething");
	}
	
	public override void DoSomething()
	{
		PreDoSomething();
		_RealA.DoSomething();
		PostDoSomething();
	}
	
	private void PostDoSomething()
	{
		WL("Yes, i'm endding DoSomething");
	}
	
	#region Helper methods

	private void WL(object text, params object[] args)
	{
		Console.WriteLine(text.ToString(), args);	
	}
	
	private void RL()
	{
		Console.ReadLine();	
	}
	
	private void Break() 
	{
		System.Diagnostics.Debugger.Break();
	}

	#endregion
}